diff --git a/source/simulation2/components/ICmpObstructionManager.cpp b/source/simulation2/components/ICmpObstructionManager.cpp
index ba4e21c..b348212 100644
--- a/source/simulation2/components/ICmpObstructionManager.cpp
+++ b/source/simulation2/components/ICmpObstructionManager.cpp
@@ -21,6 +21,10 @@
 
 #include "simulation2/system/InterfaceScripted.h"
 
+#include "graphics/Terrain.h"
+
+const fixed ICmpObstructionManager::NAVCELL_SIZE = fixed::FromInt(TERRAIN_TILE_SIZE) / NAVCELLS_PER_TILE;
+
 BEGIN_INTERFACE_WRAPPER(ObstructionManager)
 DEFINE_INTERFACE_METHOD_1("SetPassabilityCircular", void, ICmpObstructionManager, SetPassabilityCircular, bool)
 DEFINE_INTERFACE_METHOD_1("SetDebugOverlay", void, ICmpObstructionManager, SetDebugOverlay, bool)
diff --git a/source/simulation2/components/ICmpObstructionManager.h b/source/simulation2/components/ICmpObstructionManager.h
index 50f8189..b0b99c5 100644
--- a/source/simulation2/components/ICmpObstructionManager.h
+++ b/source/simulation2/components/ICmpObstructionManager.h
@@ -55,6 +55,23 @@ class ICmpObstructionManager : public IComponent
 {
 public:
 	/**
+	 * The pathfinders operate primarily over a navigation grid (a uniform-cost
+	 * 2D passability grid, with horizontal/vertical (not diagonal) connectivity).
+	 * This is based on the terrain tile passability, plus the rasterised shapes of
+	 * obstructions, all expanded outwards by the radius of the units.
+	 * Since units are much smaller than terrain tiles, the nav grid should be
+	 * higher resolution than the tiles.
+	 * We therefore split each terrain tile into NxN "nav cells" (for some integer N,
+	 * preferably a power of two).
+	 */
+	static const int NAVCELLS_PER_TILE = 4;
+
+	/**
+	 * Size of a navcell in metres ( = TERRAIN_TILE_SIZE / NAVCELLS_PER_TILE)
+	 */
+	static const fixed NAVCELL_SIZE;
+
+	/**
 	 * External identifiers for shapes.
 	 * (This is a struct rather than a raw u32 for type-safety.)
 	 */
@@ -207,7 +224,11 @@ public:
 	 * @param grid the grid to be updated
 	 * @return true if any changes were made to the grid, false if it was already up-to-date
 	 */
-	virtual bool Rasterise(Grid<u8>& grid) = 0;
+	virtual bool RasteriseOld(Grid<u8>& grid) = 0;
+
+	virtual void Rasterise(Grid<u16>& grid, entity_pos_t expand, ICmpObstructionManager::flags_t requireMask, u8 setMask) = 0;
+
+	virtual bool NeedUpdate(size_t* dirtyID) = 0;
 
 	/**
 	 * Standard representation for all types of shapes, for use with geometry processing code.
@@ -325,6 +346,8 @@ public:
 	{
 		if (group == m_Group)
 			return false;
+		if (flags & ICmpObstructionManager::FLAG_BLOCK_PATHFINDING)
+			return false;
 		if (!(flags & ICmpObstructionManager::FLAG_BLOCK_MOVEMENT))
 			return false;
 		if ((flags & ICmpObstructionManager::FLAG_MOVING) && !m_AvoidMoving)
diff --git a/source/simulation2/components/ICmpPathfinder.h b/source/simulation2/components/ICmpPathfinder.h
index ee7a300..9acede9 100644
--- a/source/simulation2/components/ICmpPathfinder.h
+++ b/source/simulation2/components/ICmpPathfinder.h
@@ -1,4 +1,4 @@
-/* Copyright (C) 2011 Wildfire Games.
+/* Copyright (C) 2012 Wildfire Games.
  * This file is part of 0 A.D.
  *
  * 0 A.D. is free software: you can redistribute it and/or modify
@@ -20,6 +20,7 @@
 
 #include "simulation2/system/Interface.h"
 
+#include "simulation2/helpers/PathGoal.h"
 #include "simulation2/helpers/Position.h"
 
 #include "maths/FixedVector2D.h"
@@ -50,17 +51,7 @@ public:
 	typedef u16 pass_class_t;
 	typedef u8 cost_class_t;
 
-	struct Goal
-	{
-		enum Type {
-			POINT,
-			CIRCLE,
-			SQUARE
-		} type;
-		entity_pos_t x, z; // position of center
-		CFixedVector2D u, v; // if SQUARE, then orthogonal unit axes
-		entity_pos_t hw, hh; // if SQUARE, then half width & height; if CIRCLE, then hw is radius
-	};
+	typedef PathGoal Goal; // XXX
 
 	struct Waypoint
 	{
@@ -102,6 +93,8 @@ public:
 	 */
 	virtual void ComputePath(entity_pos_t x0, entity_pos_t z0, const Goal& goal, pass_class_t passClass, cost_class_t costClass, Path& ret) = 0;
 
+	virtual void ComputePathJPS(entity_pos_t x0, entity_pos_t z0, const Goal& goal, pass_class_t passClass, cost_class_t costClass, Path& ret) = 0;
+
 	/**
 	 * Asynchronous version of ComputePath.
 	 * The result will be sent as CMessagePathResult to 'notify'.
@@ -178,6 +171,10 @@ public:
 	 */
 	virtual void ProcessSameTurnMoves() = 0;
 
+	virtual void GetDebugData(u32& steps, double& time, Grid<u8>& grid) = 0;
+
+	virtual void GetDebugDataJPS(u32& steps, double& time, Grid<u8>& grid) = 0;
+
 	DECLARE_INTERFACE_TYPE(Pathfinder)
 };
 
diff --git a/source/simulation2/components/ICmpTerritoryManager.h b/source/simulation2/components/ICmpTerritoryManager.h
index 575755e..f96a630 100644
--- a/source/simulation2/components/ICmpTerritoryManager.h
+++ b/source/simulation2/components/ICmpTerritoryManager.h
@@ -29,6 +29,14 @@ class ICmpTerritoryManager : public IComponent
 public:
 	virtual bool NeedUpdate(size_t* dirtyID) = 0;
 
+	/**
+	 * Number of pathfinder navcells per territory tile.
+	 * Passability data is stored per navcell, but we probably don't need that much
+	 * resolution, and a lower resolution can make the boundary lines look prettier
+	 * and will take less memory, so we downsample the passability data.
+	 */
+	static const int NAVCELLS_PER_TERRITORY_TILE = 8;
+
 	static const int TERRITORY_PLAYER_MASK = 0x3F;
 	static const int TERRITORY_CONNECTED_MASK = 0x40;
 	static const int TERRITORY_PROCESSED_MASK = 0x80; //< For internal use; marks a tile as processed.
diff --git a/source/simulation2/components/tests/test_Pathfinder.h b/source/simulation2/components/tests/test_Pathfinder.h
index 4a6c7aa..5954e4e 100644
--- a/source/simulation2/components/tests/test_Pathfinder.h
+++ b/source/simulation2/components/tests/test_Pathfinder.h
@@ -26,6 +26,7 @@
 #include "lib/timer.h"
 #include "lib/tex/tex.h"
 #include "ps/Loader.h"
+#include "ps/Pyrogenesis.h"
 #include "simulation2/Simulation2.h"
 
 class TestCmpPathfinder : public CxxTest::TestSuite
@@ -139,4 +140,161 @@ public:
 		for (size_t i = 0; i < path.m_Waypoints.size(); ++i)
 			printf("# %d: %f %f\n", (int)i, path.m_Waypoints[i].x.ToFloat(), path.m_Waypoints[i].z.ToFloat());
 	}
+
+	template<typename T>
+	void DumpGrid(std::ostream& stream, const Grid<T>& grid, int mask)
+	{
+		for (u16 j = 0; j < grid.m_H; ++j)
+		{
+			for (u16 i = 0; i < grid.m_W; )
+			{
+				if (!(grid.get(i, j) & mask))
+				{
+					i++;
+					continue;
+				}
+
+				u16 i0 = i;
+				for (i = i0+1; ; ++i)
+				{
+					if (i >= grid.m_W || !(grid.get(i, j) & mask))
+					{
+						stream << "  <rect x='" << i0 << "' y='" << j << "' width='" << (i-i0) << "' height='1'/>\n";
+						break;
+					}
+				}
+			}
+		}
+	}
+
+#define USE_JPS 1
+
+	void test_perf2()
+	{
+		CTerrain terrain;
+
+		CSimulation2 sim2(NULL, &terrain);
+		sim2.LoadDefaultScripts();
+		sim2.ResetState();
+
+		CMapReader* mapReader = new CMapReader(); // it'll call "delete this" itself
+
+		LDR_BeginRegistering();
+		mapReader->LoadMap(L"maps/scenarios/Peloponnese.pmp", &terrain, NULL, NULL, NULL, NULL, NULL, NULL,
+			&sim2, &sim2.GetSimContext(), -1, false);
+		LDR_EndRegistering();
+		TS_ASSERT_OK(LDR_NonprogressiveLoad());
+
+		sim2.Update(0);
+
+		std::ofstream stream(OsString("perf2.html").c_str(), std::ofstream::out | std::ofstream::trunc);
+
+		CmpPtr<ICmpObstructionManager> cmpObstructionManager(sim2, SYSTEM_ENTITY);
+		CmpPtr<ICmpPathfinder> cmpPathfinder(sim2, SYSTEM_ENTITY);
+
+		ICmpPathfinder::pass_class_t obstructionsMask = cmpPathfinder->GetPassabilityClass("default") | ICmpObstructionManager::TILE_OBSTRUCTED_PATHFINDING;
+		const Grid<u16>& obstructions = cmpPathfinder->GetPassabilityGrid();
+
+		int scale = 1;
+		stream << "<!DOCTYPE html>\n";
+		stream << "<style>\n";
+		stream << ".passability rect { fill: black; }\n";
+		stream << ".astar-open rect { fill: rgba(255,255,0,0.75); }\n";
+		stream << ".astar-closed rect { fill: rgba(255,0,0,0.75); }\n";
+//		stream << ".astar-closed rect { fill: rgba(0,255,0,0.75); }\n";
+		stream << ".path { stroke: rgba(0,0,255,0.75); stroke-width: 1; fill: none; }\n";
+		stream << "</style>\n";
+		stream << "<svg width='" << obstructions.m_W*scale << "' height='" << obstructions.m_H*scale << "'>\n";
+		stream << "<g transform='translate(0 " << obstructions.m_H*scale << ") scale(" << scale << " -" << scale << ")'>\n";
+
+		stream << " <g class='passability'>\n";
+		DumpGrid(stream, obstructions, obstructionsMask);
+		stream << " </g>\n";
+
+		DumpPath(stream, 128, 256, 128, 384, cmpPathfinder);
+// 	  	RepeatPath(500, 128, 256, 128, 384, cmpPathfinder);
+// //		RepeatPath(100, 128, 256, 128, 384, cmpPathfinder);
+// 
+// 		DumpPath(stream, 128, 204, 192, 204, cmpPathfinder);
+// 
+// 		DumpPath(stream, 128, 230, 32, 230, cmpPathfinder);
+
+		stream << "</g>\n";
+		stream << "</svg>\n";
+	}
+
+	void DumpPath(std::ostream& stream, int i0, int j0, int i1, int j1, CmpPtr<ICmpPathfinder>& cmpPathfinder)
+	{
+		entity_pos_t x0 = entity_pos_t::FromInt(i0*TERRAIN_TILE_SIZE);
+		entity_pos_t z0 = entity_pos_t::FromInt(j0*TERRAIN_TILE_SIZE);
+		entity_pos_t x1 = entity_pos_t::FromInt(i1*TERRAIN_TILE_SIZE);
+		entity_pos_t z1 = entity_pos_t::FromInt(j1*TERRAIN_TILE_SIZE);
+
+		ICmpPathfinder::Goal goal = { ICmpPathfinder::Goal::POINT, x1, z1 };
+
+		ICmpPathfinder::Path path;
+#if USE_JPS
+		cmpPathfinder->ComputePathJPS(x0, z0, goal, cmpPathfinder->GetPassabilityClass("default"), cmpPathfinder->GetCostClass("default"), path);
+#else
+		cmpPathfinder->ComputePath(x0, z0, goal, cmpPathfinder->GetPassabilityClass("default"), cmpPathfinder->GetCostClass("default"), path);
+#endif
+
+		u32 debugSteps;
+		double debugTime;
+		Grid<u8> debugGrid;
+#if USE_JPS
+		cmpPathfinder->GetDebugDataJPS(debugSteps, debugTime, debugGrid);
+#else
+		cmpPathfinder->GetDebugData(debugSteps, debugTime, debugGrid);
+#endif
+// 		stream << " <g style='visibility:hidden'>\n";
+		stream << " <g>\n";
+		stream << " <g class='astar-open'>\n";
+		DumpGrid(stream, debugGrid, 1);
+		stream << " </g>\n";
+		stream << " <g class='astar-closed'>\n";
+		DumpGrid(stream, debugGrid, 2);
+		stream << " </g>\n";
+		stream << " </g>\n";
+
+		stream << " <polyline";
+		stream << " onmouseover='this.previousElementSibling.style.visibility=\"visible\"' onmouseout='this.previousElementSibling.style.visibility=\"hidden\"'";
+		double length = 0;
+		for (ssize_t i = 0; i < (ssize_t)path.m_Waypoints.size()-1; ++i)
+		{
+			double dx = (path.m_Waypoints[i+1].x - path.m_Waypoints[i].x).ToDouble();
+			double dz = (path.m_Waypoints[i+1].z - path.m_Waypoints[i].z).ToDouble();
+			ENSURE(dx == 0 || dz == 0 || abs(dx) == abs(dz));
+			length += sqrt(dx*dx + dz*dz);
+		}
+		stream << " title='length: " << length << "; tiles explored: " << debugSteps << "; time: " << debugTime*1000 << " msec'";
+		stream << " class='path' points='";
+		for (size_t i = 0; i < path.m_Waypoints.size(); ++i)
+			stream << path.m_Waypoints[i].x.ToDouble()*ICmpObstructionManager::NAVCELLS_PER_TILE/TERRAIN_TILE_SIZE << "," << path.m_Waypoints[i].z.ToDouble()*ICmpObstructionManager::NAVCELLS_PER_TILE/TERRAIN_TILE_SIZE << " ";
+		stream << "'/>\n";
+	}
+
+	void RepeatPath(int n, int i0, int j0, int i1, int j1, CmpPtr<ICmpPathfinder>& cmpPathfinder)
+	{
+		entity_pos_t x0 = entity_pos_t::FromInt(i0*TERRAIN_TILE_SIZE);
+		entity_pos_t z0 = entity_pos_t::FromInt(j0*TERRAIN_TILE_SIZE);
+		entity_pos_t x1 = entity_pos_t::FromInt(i1*TERRAIN_TILE_SIZE);
+		entity_pos_t z1 = entity_pos_t::FromInt(j1*TERRAIN_TILE_SIZE);
+
+		ICmpPathfinder::Goal goal = { ICmpPathfinder::Goal::POINT, x1, z1 };
+
+		double t = timer_Time();
+		for (int i = 0; i < n; ++i)
+		{
+			ICmpPathfinder::Path path;
+#if USE_JPS
+			cmpPathfinder->ComputePathJPS(x0, z0, goal, cmpPathfinder->GetPassabilityClass("default"), cmpPathfinder->GetCostClass("default"), path);
+#else
+			cmpPathfinder->ComputePath(x0, z0, goal, cmpPathfinder->GetPassabilityClass("default"), cmpPathfinder->GetCostClass("default"), path);
+#endif
+		}
+		t = timer_Time() - t;
+		debug_printf(L"### RepeatPath %fms each (%fs total)\n", 1000*t / n, t);
+	}
+
 };
diff --git a/source/simulation2/helpers/Grid.h b/source/simulation2/helpers/Grid.h
index fc087a2..2bbb700 100644
--- a/source/simulation2/helpers/Grid.h
+++ b/source/simulation2/helpers/Grid.h
@@ -48,6 +48,7 @@ public:
 
 	Grid(const Grid& g)
 	{
+		m_Data = NULL;
 		*this = g;
 	}
 
@@ -60,6 +61,7 @@ public:
 			m_DirtyID = g.m_DirtyID;
 			if (g.m_Data)
 			{
+				delete[] m_Data;
 				m_Data = new T[m_W * m_H];
 				memcpy(m_Data, g.m_Data, m_W*m_H*sizeof(T));
 			}
@@ -80,6 +82,13 @@ public:
 			memset(m_Data, 0, m_W*m_H*sizeof(T));
 	}
 
+	void unsetMask(T mask)
+	{
+		T inverse = ~mask;
+		for (int n = 0; n < m_W*m_H; ++n)
+			m_Data[n] &= inverse;
+	}
+
 	void set(int i, int j, const T& value)
 	{
 #if GRID_BOUNDS_DEBUG
@@ -102,6 +111,107 @@ public:
 	size_t m_DirtyID; // if this is < the id maintained by ICmpObstructionManager then it needs to be updated
 };
 
+class BitGrid
+{
+public:
+	BitGrid() : m_W(0), m_H(0), m_RowStride(0), m_Data(NULL)
+	{
+	}
+
+	BitGrid(u16 w, u16 h) : m_W(w), m_H(h), m_RowStride((w+7)/8), m_Data(NULL)
+	{
+		if (m_W || m_H)
+			m_Data = (u8*)malloc(m_RowStride * m_H);
+		reset();
+	}
+
+	BitGrid(const BitGrid& g)
+	{
+		*this = g;
+	}
+
+	BitGrid& operator=(const BitGrid& g)
+	{
+		if (this != &g)
+		{
+			m_W = g.m_W;
+			m_H = g.m_H;
+			m_RowStride = g.m_RowStride;
+			if (g.m_Data)
+			{
+				free(m_Data);
+				m_Data = (u8*)malloc(m_RowStride * m_H);
+				memcpy(m_Data, g.m_Data, m_RowStride * m_H);
+			}
+			else
+				m_Data = NULL;
+		}
+		return *this;
+	}
+
+	~BitGrid()
+	{
+		free(m_Data);
+	}
+
+	void reset()
+	{
+		if (m_Data)
+			memset(m_Data, 0, m_RowStride * m_H);
+	}
+
+	void set(int i, int j, bool value)
+	{
+#if GRID_BOUNDS_DEBUG
+		ENSURE(0 <= i && i < m_W && 0 <= j && j < m_H);
+#endif
+		m_Data[j*m_RowStride + (i >> 3)] &= ~(1 << (i & 7));
+		m_Data[j*m_RowStride + (i >> 3)] |= value << (i & 7);
+	}
+
+	bool get(int i, int j) const
+	{
+#if GRID_BOUNDS_DEBUG
+		ENSURE(0 <= i && i < m_W && 0 <= j && j < m_H);
+#endif
+		return (m_Data[j*m_RowStride + (i >> 3)] & (1 << (i & 7))) != 0;
+	}
+
+	u8 get8(int i, int j) const
+	{
+#if GRID_BOUNDS_DEBUG
+		ENSURE(0 <= i && i < m_W && 0 <= j && j < m_H);
+#endif
+		return m_Data[j*m_RowStride + (i >> 3)];
+	}
+
+	bool getz(int i, int j) const
+	{
+		if ((i & 7) == 7)
+		{
+			u8 a = m_Data[(j-1)*m_RowStride + (i >> 3)];
+			//u8 b = m_Data[j*m_RowStride + (i >> 3)];
+			u8 c = m_Data[(j+1)*m_RowStride + (i >> 3)];
+			u8 a2 = m_Data[(j-1)*m_RowStride + (i >> 3) + 1];
+			u8 c2 = m_Data[(j+1)*m_RowStride + (i >> 3) + 1];
+			return (!(a & 128) && (a2 & 1)) || (!(c & 128) && (c2 & 1));
+		}
+		else
+		{
+			u8 a = m_Data[(j-1)*m_RowStride + (i >> 3)];
+			//u8 b = m_Data[j*m_RowStride + (i >> 3)];
+			u8 c = m_Data[(j+1)*m_RowStride + (i >> 3)];
+			return ((a & (3 << (i & 7))) == (2 << (i & 7)) || (c & (3 << (i & 7))) == (2 << (i & 7)));
+		}
+	}
+
+	u16 m_W, m_H;
+	u16 m_RowStride;
+	u8* m_Data;
+
+	size_t m_DirtyID; // if this is < the id maintained by ICmpObstructionManager then it needs to be updated
+};
+
 /**
  * Similar to Grid, except optimised for sparse usage (the grid is subdivided into
  * buckets whose contents are only initialised on demand, to save on memset cost).
diff --git a/source/simulation2/helpers/PathGoal.cpp b/source/simulation2/helpers/PathGoal.cpp
new file mode 100644
index 0000000..b7cafa9
--- /dev/null
+++ b/source/simulation2/helpers/PathGoal.cpp
@@ -0,0 +1,91 @@
+/* Copyright (C) 2012 Wildfire Games.
+ * This file is part of 0 A.D.
+ *
+ * 0 A.D. is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * 0 A.D. is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with 0 A.D.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include "precompiled.h"
+
+#include "PathGoal.h"
+
+#include "graphics/Terrain.h"
+#include "simulation2/components/ICmpObstructionManager.h"
+#include "simulation2/helpers/Geometry.h"
+
+bool PathGoal::NavcellContainsGoal(u16 i, u16 j) const
+{
+	switch (type)
+	{
+	case POINT:
+	{
+		u16 gi, gj;
+		gi = (u16)(x * ICmpObstructionManager::NAVCELLS_PER_TILE / (int)TERRAIN_TILE_SIZE).ToInt_RoundToZero();
+		gj = (u16)(z * ICmpObstructionManager::NAVCELLS_PER_TILE / (int)TERRAIN_TILE_SIZE).ToInt_RoundToZero();
+		return gi == i && gj == j;
+	}
+	case CIRCLE:
+	{
+		entity_pos_t x0 = entity_pos_t::FromInt(i).Multiply(ICmpObstructionManager::NAVCELL_SIZE);
+		entity_pos_t z0 = entity_pos_t::FromInt(j).Multiply(ICmpObstructionManager::NAVCELL_SIZE);
+		entity_pos_t x1 = x0 + ICmpObstructionManager::NAVCELL_SIZE;
+		entity_pos_t z1 = z0 + ICmpObstructionManager::NAVCELL_SIZE;
+		entity_pos_t nx = Clamp(x, x0, x1);
+		entity_pos_t nz = Clamp(z, z0, z1);
+		return (CFixedVector2D(nx, nz) - CFixedVector2D(x, z)).CompareLength(hw) <= 0;
+	}
+	case SQUARE:
+	{
+		entity_pos_t x0 = entity_pos_t::FromInt(i).Multiply(ICmpObstructionManager::NAVCELL_SIZE);
+		entity_pos_t z0 = entity_pos_t::FromInt(j).Multiply(ICmpObstructionManager::NAVCELL_SIZE);
+		entity_pos_t x1 = x0 + ICmpObstructionManager::NAVCELL_SIZE;
+		entity_pos_t z1 = z0 + ICmpObstructionManager::NAVCELL_SIZE;
+		entity_pos_t nx = Clamp(x, x0, x1);
+		entity_pos_t nz = Clamp(z, z0, z1);
+		return Geometry::PointIsInSquare(CFixedVector2D(nx - x, nz - z), u, v, CFixedVector2D(hw, hh));
+	}
+	default:
+	{
+		debug_warn(L"invalid type");
+		return false;
+	}
+	}
+}
+
+bool PathGoal::RectContainsGoal(entity_pos_t x0, entity_pos_t z0, entity_pos_t x1, entity_pos_t z1) const
+{
+	switch (type)
+	{
+	case POINT:
+	{
+		return x0 <= x && x <= x1 && z0 <= z && z <= z1;
+	}
+	case CIRCLE:
+	{
+		entity_pos_t nx = Clamp(x, x0, x1);
+		entity_pos_t nz = Clamp(z, z0, z1);
+		return (CFixedVector2D(nx, nz) - CFixedVector2D(x, z)).CompareLength(hw) <= 0;
+	}
+	case SQUARE:
+	{
+		entity_pos_t nx = Clamp(x, x0, x1);
+		entity_pos_t nz = Clamp(z, z0, z1);
+		return Geometry::PointIsInSquare(CFixedVector2D(nx - x, nz - z), u, v, CFixedVector2D(hw, hh));
+	}
+	default:
+	{
+		debug_warn(L"invalid type");
+		return false;
+	}
+	}
+}
diff --git a/source/simulation2/helpers/PathGoal.h b/source/simulation2/helpers/PathGoal.h
new file mode 100644
index 0000000..353c71d
--- /dev/null
+++ b/source/simulation2/helpers/PathGoal.h
@@ -0,0 +1,48 @@
+/* Copyright (C) 2012 Wildfire Games.
+ * This file is part of 0 A.D.
+ *
+ * 0 A.D. is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * 0 A.D. is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with 0 A.D.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef INCLUDED_PATHGOAL
+#define INCLUDED_PATHGOAL
+
+#include "maths/FixedVector2D.h"
+#include "simulation2/helpers/Position.h"
+
+class PathGoal
+{
+public:
+	enum Type {
+		POINT,
+		CIRCLE,
+		SQUARE
+	} type;
+
+	entity_pos_t x, z; // position of center
+
+	CFixedVector2D u, v; // if SQUARE, then orthogonal unit axes
+
+	entity_pos_t hw, hh; // if SQUARE, then half width & height; if CIRCLE, then hw is radius
+
+	bool NavcellContainsGoal(u16 i, u16 j) const;
+
+	/**
+	 * Returns true if the rectangle defined by (x0,z0)-(x1,z1) (inclusive)
+	 * contains a part of the goal area.
+	 */
+	bool RectContainsGoal(entity_pos_t x0, entity_pos_t z0, entity_pos_t x1, entity_pos_t z1) const;
+};
+
+#endif // INCLUDED_PATHGOAL
diff --git a/source/simulation2/helpers/PriorityQueue.h b/source/simulation2/helpers/PriorityQueue.h
index 9e7c8e3..0d10816 100644
--- a/source/simulation2/helpers/PriorityQueue.h
+++ b/source/simulation2/helpers/PriorityQueue.h
@@ -32,14 +32,13 @@
 template <typename Item, typename CMP>
 struct QueueItemPriority
 {
-	bool operator()(const Item& a, const Item& b)
+	bool operator()(const Item& a, const Item& b) const
 	{
 		if (CMP()(b.rank, a.rank)) // higher costs are lower priority
 			return true;
 		if (CMP()(a.rank, b.rank))
 			return false;
 		// Need to tie-break to get a consistent ordering
-		// TODO: Should probably tie-break on g or h or something, but don't bother for now
 		if (a.id < b.id)
 			return true;
 		if (b.id < a.id)
@@ -73,19 +72,10 @@ public:
 		push_heap(m_Heap.begin(), m_Heap.end(), QueueItemPriority<Item, CMP>());
 	}
 
-	Item* find(ID id)
-	{
-		for (size_t n = 0; n < m_Heap.size(); ++n)
-		{
-			if (m_Heap[n].id == id)
-				return &m_Heap[n];
-		}
-		return NULL;
-	}
-
-	void promote(ID id, R newrank)
+	void promote(ID id, R UNUSED(oldrank), R newrank)
 	{
-		for (size_t n = 0; n < m_Heap.size(); ++n)
+		// Loop backwards since it seems a little faster in practice
+		for (ssize_t n = m_Heap.size() - 1; n >= 0; --n)
 		{
 			if (m_Heap[n].id == id)
 			{
@@ -93,7 +83,7 @@ public:
 				ENSURE(m_Heap[n].rank > newrank);
 #endif
 				m_Heap[n].rank = newrank;
-				push_heap(m_Heap.begin(), m_Heap.begin()+n+1, QueueItemPriority<Item, CMP>());
+ 				push_heap(m_Heap.begin(), m_Heap.begin()+n+1, QueueItemPriority<Item, CMP>());
 				return;
 			}
 		}
@@ -104,8 +94,8 @@ public:
 #if PRIORITYQUEUE_DEBUG
 		ENSURE(m_Heap.size());
 #endif
-		Item r = m_Heap.front();
-		pop_heap(m_Heap.begin(), m_Heap.end(), QueueItemPriority<Item, CMP>());
+		Item r = m_Heap[0];
+ 		pop_heap(m_Heap.begin(), m_Heap.end(), QueueItemPriority<Item, CMP>());
 		m_Heap.pop_back();
 		return r;
 	}
@@ -155,7 +145,7 @@ public:
 		return NULL;
 	}
 
-	void promote(ID id, R newrank)
+	void promote(ID id, R UNUSED(oldrank), R newrank)
 	{
 		find(id)->rank = newrank;
 	}
diff --git a/source/simulation2/helpers/Render.cpp b/source/simulation2/helpers/Render.cpp
index a8d9b3431..7a3c4dd 100644
--- a/source/simulation2/helpers/Render.cpp
+++ b/source/simulation2/helpers/Render.cpp
@@ -100,6 +100,52 @@ void SimRender::ConstructCircleOnGround(const CSimContext& context, float x, flo
 	}
 }
 
+void SimRender::ConstructClosedArcOnGround(const CSimContext& context, float x, float z, float radius,
+	float start, float end,
+	SOverlayLine& overlay, bool floating, float heightOffset)
+{
+	overlay.m_Coords.clear();
+
+	CmpPtr<ICmpTerrain> cmpTerrain(context, SYSTEM_ENTITY);
+	if (cmpTerrain.null())
+		return;
+
+	float water = 0.f;
+	if (floating)
+	{
+		CmpPtr<ICmpWaterManager> cmpWaterMan(context, SYSTEM_ENTITY);
+		if (!cmpWaterMan.null())
+			water = cmpWaterMan->GetExactWaterLevel(x, z);
+	}
+
+	// Adapt the circle resolution to look reasonable for small and largeish radiuses
+	size_t numPoints = clamp((size_t)(radius*4.0f), (size_t)12, (size_t)48);
+
+	overlay.m_Coords.reserve((numPoints + 1 + 2) * 3);
+
+	// Start at the center point
+	float cy = std::max(water, cmpTerrain->GetExactGroundLevel(x, z)) + heightOffset;
+	overlay.m_Coords.push_back(x);
+	overlay.m_Coords.push_back(cy);
+	overlay.m_Coords.push_back(z);
+
+	for (size_t i = 0; i <= numPoints; ++i) // use '<=' so it's a closed loop
+	{
+		float a = start + (float)i * (end - start) / (float)numPoints;
+		float px = x + radius * cosf(a);
+		float pz = z + radius * sinf(a);
+		float py = std::max(water, cmpTerrain->GetExactGroundLevel(px, pz)) + heightOffset;
+		overlay.m_Coords.push_back(px);
+		overlay.m_Coords.push_back(py);
+		overlay.m_Coords.push_back(pz);
+	}
+
+	// Return to the center point
+	overlay.m_Coords.push_back(x);
+	overlay.m_Coords.push_back(cy);
+	overlay.m_Coords.push_back(z);
+}
+
 // This method splits up a straight line into a number of line segments each having a length ~= TERRAIN_TILE_SIZE
 static void SplitLine(std::vector<std::pair<float, float> >& coords, float x1, float y1, float x2, float y2)
 {
diff --git a/source/simulation2/helpers/Render.h b/source/simulation2/helpers/Render.h
index 2ce2837..0283316 100644
--- a/source/simulation2/helpers/Render.h
+++ b/source/simulation2/helpers/Render.h
@@ -72,6 +72,14 @@ void ConstructCircleOnGround(const CSimContext& context, float x, float z, float
 		bool floating, float heightOffset = 0.25f);
 
 /**
+ * Updates @p overlay so that it represents the given circle, flattened on the terrain.
+ */
+void ConstructClosedArcOnGround(const CSimContext& context, float x, float z, float radius,
+		float start, float end,
+		SOverlayLine& overlay,
+		bool floating, float heightOffset = 0.25f);
+
+/**
  * Updates @p overlay so that it represents the given square, flattened on the terrain.
  * @p x and @p z are position of center, @p w and @p h are size of rectangle, @p a is clockwise angle.
  */
